
import { _decorator, Component, Node, sp, Label, EventTouch } from 'cc';
import { DEV } from 'cc/env';
import { DevFlag } from './core/Utils/Log';
import AutoLayout from './view/component/AutoLayout';
const { ccclass, property } = _decorator;

@ccclass('TestSpine')
export class TestSpine extends Component {
    @property(sp.Skeleton)
    ske: sp.Skeleton = null;

    @property(AutoLayout)
    alAni: AutoLayout = null;

    aniNames: string[];

    start() {
        this.ske.setCompleteListener(this.onComplete.bind(this));
        this.aniNames = Object.keys(this.ske.skeletonData._skeletonJson.animations);
        this.aniNames.push('stop');
        this.alAni.numItems = this.aniNames.length;
    }

    onALAniRender(item: any, idx: number) {
        item.getComponentInChildren(Label).string = this.aniNames[idx];
    }

    btnEv(ev: EventTouch) {
        let target = ev.currentTarget as Node;
        let idx = target.getSiblingIndex();
        let aniName = this.aniNames[idx];
        if (aniName == 'stop') {
            // this.ske.clearTrack(0);
            this.ske.node.active = false;
        } else {
            this.ske.setAnimation(0, aniName, true);
        }
    }

    onComplete() {
        DEV && DevFlag.kl && console.log('onComplete');
    }

    // update (deltaTime: number) {
    //     // [4]
    // }
}
