import { _decorator, Component, Node, Camera, isValid, Vec3, Prefab, instantiate, NodePool, tween, Label, UIOpacity, easing, BitmapFont, EventTouch, Vec2 } from 'cc';
import { DEV } from 'cc/env';
import { RoleResPath, RoleDir, RoleAni } from './RoleVo2D';
import { RoleVo2D } from './RoleVo2D';
const { ccclass, property } = _decorator;

export enum TextType {
    NUMBER = 1,
    MISS = 'm',
    CRIT = 'c',
}

@ccclass('BattleScene')
export class BattleScene extends Component {


    // 摄像机
    @property(Camera)
    camera: Camera = null;

    // 拖拽节点
    private dragNode: Node;

    // 角色 Spine
    @property(Node)
    public roleLayer: Node = null;  //角色层

    @property(Prefab)
    private roleVoPf: Prefab = null;//人物显示节点预制体

    private rolePool: NodePool = new NodePool();// 角色节点池

    // 计算 SiblingIndex 的帧数
    private calcSiblingIndexFrame = 0;
    @property(Node)
    private fightBG: Node = null;//背景图节点

    // 特效
    @property(Node)
    private skillEffectLayer: Node = null;// 特效层
    private skillEffectPool: NodePool = new NodePool();//特效节点池
    @property(Prefab)
    private skillEffectVoPf: Prefab = null;// 特效显示节点预制体

    // 人物信息
    @property(Node)
    private roleInfoLayer: Node = null;
    @property(Prefab)
    private roleInfoPf: Prefab = null;// 人物信息预制体
    private roleInfoPool: NodePool = new NodePool();// 人物信息池子

    // 人物文本信息
    @property(Node)
    private roleTextInfoLayer: Node = null;
    @property(Prefab)
    private roleTextoPf: Prefab = null;// 人物文本信息预制体
    private roleTextoPool: NodePool = new NodePool();// 人物文本信息池子

    // 飘字
    @property(Node)
    private textLayer: Node = null;  //飘字层
    @property(Prefab)
    private textPf: Prefab = null;// 飘字预制体
    private textPool: NodePool = new NodePool();// 飘字节点池
    @property(BitmapFont)
    bmf_fight: BitmapFont = null;

    @property(BitmapFont)
    bmf_fight_mag_crit: BitmapFont = null;

    @property(BitmapFont)
    bmf_fight_mult_crit: BitmapFont = null;

    @property(BitmapFont)
    bmf_fight_phy_crit: BitmapFont = null;

    onLoad() {
        globalThis.BattleScene = this;
    }

    start() {
    }

    onEnable() {

        // this.node.on(Node.EventType.TOUCH_START, this.onTouchStart);
        // this.node.on(Node.EventType.TOUCH_START, this.onTouchEnd);
        // this.node.on(Node.EventType.TOUCH_START, this.onTouchMove);
    }

    private ids: number[] = [];
    private XY: Map<number, Vec2> = new Map();
    private lastDis: number = 0;
    onTouchStart(event: EventTouch) {
        if (this.ids.length < 2) {
            let id = event.getID();
            this.ids.push(id);
            this.XY.set(id, event.getUILocation());
            if (this.ids.length == 2) {
                let id1 = this.ids[0];
                let id2 = this.ids[1];
                let v21 = this.XY.get(id1);
                let v22 = this.XY.get(id2);


            }
        }

    }

    onTouchEnd(event: EventTouch) {
        let id = event.getID();
        let index = this.ids.indexOf(id);
        if (index != -1) {
            this.XY.delete(id);
            this.ids.splice(index, 1);
        }
    }

    onTouchMove(event: EventTouch) {
    }

    // moveDrag(location: Vec2) {
    // }


    // ----------------------------------- effect ended -----------------------------------

}
