
import { _decorator, Component, Node, sp, resources, ProgressBar, Vec3, Camera, EventTouch, UIOpacity, UITransform, Vec2, Touch, Size, Game, isValid } from 'cc';
import { DEV } from 'cc/env';
import { BattleScene, TextType } from './BattleScene';
const { ccclass, property } = _decorator;

export enum RoleDir {
    RIGHT = 1,
    RIGHT_BACK = 2,
    BACK = 3,
    LEFT_BACK = 4,
    LEFT = 5,
    LEFT_FRONT = 6,
    FRONT = 7,
    RIGHT_FRONT = 8,
}

export enum RoleResPath {
    HERO = 'hero',
    ENEMY = 'enemy',
}

export enum RoleAni {
    ATTACK = 'att',
    DIE = 'die',
    STANDBY = 'standby',
    RUN = 'run',
}

@ccclass('RoleVo2D')
export class RoleVo2D extends Component {


    @property(sp.Skeleton)
    private ske: sp.Skeleton;  // Spine 组件

    @property(UIOpacity)
    public skeUIO: UIOpacity;  // 透明度 组件

    @property(Node)
    private touchN: Node;// 触摸节点

    @property(Node)
    public skillEffectCtn: Node;  // 特效容器

    private lastSkeUrl: string; // 最后一次加载的 Spine URL
    private playingAni: string; // 正在播放的动作名称

    private frontQualifier: string = '1';   //正面动作附加词

    private _dir: RoleDir; // 方向

    private _waitPlayAni: any[];// 等待播放动作

    private startPos: Vec3;
    private nextPos: Vec3;
    private _pathDur: number;
    private _pathDurAdd: number;

    public _voBaseScale: number; // 基本 scale

    constructor(){
        super();
        this.skeUIO.opacity = 0;
    }
    


    public set voBaseScale(val: number) {
        this._voBaseScale = val;
    }
    public get voBaseScale(): number {
        return this._voBaseScale;
    }

    public isDrag: boolean;

    private deathFadeOut: boolean;
    private inFadein: boolean;

    private beforeDragPos: Vec3;    // 拖拽移动前的位置


    get dir(): RoleDir {
        return this._dir;
    }

    set dir(val: RoleDir) {
        this._dir = val;
        switch (val) {
            case RoleDir.LEFT_FRONT:
                this.ske.node.setScale(-1, 1, 1);
                break;
            case RoleDir.LEFT_BACK:
                this.ske.node.setScale(1, 1, 1);
                break;
            case RoleDir.RIGHT_FRONT:
                this.ske.node.setScale(1, 1, 1);
                break;
            case RoleDir.RIGHT_BACK:
                this.ske.node.setScale(-1, 1, 1);
                break;
        }
    }

    private skilllogicuid: number;

    private _hasRegEv: boolean; // 是否注事件

    private touchStartPos: Vec2;
    private touchLongDur: number = .4;  // 长按时长
    private touchLongCurDur: number;
    private touching: boolean;
    private touchLastLoc: Vec2;

    private touchNInitSize: Size;

    public isHeroMove: boolean;

    onLoad() {
    }

   

}

